<?php

require_once('BlogEntry.class.php');

class BlogDBM {

	function BlogDBM() { }

	function createCategory($titel, $user_id) {
		$id = md5(uniqid(time().$titel.$user_id));
		$db=new DB_Seminar;
		$db->queryf("INSERT INTO blog_categories (cat_id, user_id, title) VALUES ('%s','%s','%s')",$id, $user_id, mysql_escape_string($titel));
	}

	function getPublicDates($user_id) {
		$ret = array();
		$db=new DB_Seminar;
		//$db->query("SELECT DISTINCT FROM_UNIXTIME(mkdate, '%Y-%m') datum, UNIX_TIMESTAMP(FROM_UNIXTIME(mkdate, '%Y-%m-01')) datum_ts FROM blog_entries WHERE user_id='".$user_id."' AND visible=1 ORDER BY datum DESC");
		$db->query("SELECT FROM_UNIXTIME(mkdate, '%Y-%m') datum, UNIX_TIMESTAMP(FROM_UNIXTIME(mkdate, '%Y-%m-01')) datum_ts, COUNT(entry_id) count_entries FROM blog_entries WHERE user_id='".$user_id."' AND visible=1 GROUP BY datum ORDER BY datum DESC");
		while ($db->next_record())
			array_push($ret, $db->Record);
		return $ret;
	}

	function getAdminDates($user_id) {
		$ret = array();
		$db=new DB_Seminar;
		$db->query("SELECT DISTINCT FROM_UNIXTIME(mkdate, '%Y-%m') datum, UNIX_TIMESTAMP(FROM_UNIXTIME(mkdate, '%Y-%m-01')) datum_ts, COUNT(entry_id) count_entries FROM blog_entries WHERE user_id='".$user_id."' GROUP BY datum ORDER BY datum DESC");
		while ($db->next_record())
			array_push($ret, $db->Record);
		return $ret;
	}

	function getPublicCategories($user_id) {
		$db=new DB_Seminar;
		$ret = array();
		$db->queryf("SELECT c.*, COUNT(ce.entry_id) count_entries FROM blog_categories c LEFT JOIN blog_category_entry ce USING (cat_id) LEFT JOIN blog_entries e USING (entry_id) WHERE c.user_id='%s' AND e.visible=1 GROUP BY c.cat_id ORDER BY c.title",$user_id);
		while ($db->next_record()) {
			$db->Record['title'] = stripslashes(stripslashes($db->Record['title']));
			array_push($ret, $db->Record);
		}
		return $ret;
	}

	function getAdminCategories($user_id) {
		$db=new DB_Seminar;
		$ret = array();
		$db->queryf("SELECT c.*, COUNT(ce.entry_id) count_entries FROM blog_categories c LEFT JOIN blog_category_entry ce USING (cat_id) WHERE c.user_id='%s' GROUP BY c.cat_id ORDER BY c.title",$user_id);
		while ($db->next_record()) {
			$db->Record['title'] = stripslashes(stripslashes($db->Record['title']));
			array_push($ret, $db->Record);
		}
		return $ret;
	}

	function getCategory($cat_id) {
		$db=new DB_Seminar;
		$db->queryf("SELECT c.*, COUNT(ce.entry_id) count_entries FROM blog_categories c LEFT JOIN blog_category_entry ce USING (cat_id) WHERE c.cat_id='%s' GROUP BY c.cat_id",$cat_id);
		if ($db->next_record()) {
			$db->Record['title'] = stripslashes(stripslashes($db->Record['title']));
			return $db->Record;
		} else
			return FALSE;
	}

	function deleteCategory($id) {
		$db=new DB_Seminar;
		$db->queryf("DELETE FROM blog_categories WHERE cat_id='%s' AND user_id='%s'",$id, $GLOBALS['auth']->auth['uid']);
	}

	function updateCategory($id, $title) {
		$db=new DB_Seminar;
		$db->queryf("UPDATE blog_categories SET title='%s' WHERE cat_id='%s' AND user_id='%s'",mysql_escape_string($title), $id, $GLOBALS['auth']->auth['uid']);
	}

	function get_email($user_id="") {
	        $db=new DB_Seminar;
        	$db->query ("SELECT Email FROM auth_user_md5 WHERE user_id = '$user_id'");
	        while ($db->next_record())
        	        $author=$db->f("Email");
	        if ($author=="") $author= _("unbekannt");
		return $author;
	}


	function hasPublicEntries($user_id) {
		$db = new DB_Seminar();
                $db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1",$user_id);
		return ($db->num_rows() > 0 ? TRUE : FALSE);
	}

	function getActivePublicBlogger($limit=FALSE) {
		$ret = array();
		$db = new DB_Seminar();
                $db->queryf("SELECT user_id, COUNT(entry_id) count_entries FROM blog_entries WHERE visible=1 GROUP BY user_id ORDER BY count_entries DESC %s",($limit ? "LIMIT 0,$limit" : ""));
		while ($db->next_record()) {
			array_push($ret, array('user_id'=>$db->f('user_id'),'count_entries'=>$db->f('count_entries')));
		}
		return $ret;
	}

	function getPublicEntries($user_id, $limit=FALSE) {
		$ret = array();
		$db = new DB_Seminar();
                $db->queryf("SELECT entry_id FROM blog_entries WHERE user_id='%s' AND visible=1 ORDER BY mkdate DESC %s",$user_id, ($limit ? "LIMIT 0,$limit" : ""));
		while ($db->next_record()) {
			$e = new BlogEntry();
			$e->load($db->f('entry_id'));
			array_push($ret, $e);
		}
		return $ret;
	}

	function getAllEntries($user_id, $limit=FALSE, $datum=FALSE) {
		$ret = array();
		$db = new DB_Seminar();
                $db->queryf("SELECT entry_id FROM blog_entries WHERE user_id='%s' %s ORDER BY mkdate DESC %s",$user_id, ($datum ? "AND FROM_UNIXTIME(mkdate, '%Y-%m-01')='".date('Y-m-01',$datum)."'" : ""), ($limit ? "LIMIT 0,$limit" : ""));
		while ($db->next_record()) {
			$e = new BlogEntry();
			$e->load($db->f('entry_id'));
			array_push($ret, $e);
		}
		return $ret;
	}

	function getEntryIdFromPermid($id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT entry_id FROM blog_entries WHERE permanent_id=%d",$id);
		if ($db->next_record())
			return $db->f('entry_id');
		else
			return FALSE;
	}

	function getTrackbackUris($e, $permalink) {
                $ret = array();
                $db = new DB_Seminar();
                $uri = $permalink.$e->getPermanentId();
                $db->queryf("SELECT * FROM blog_entries WHERE user_id!='%s' AND visible=1 AND description LIKE '%s'",$e->getUserId,"%".$uri."%");
                while ($db->next_record()) {
                        array_push($ret,array('permalink'=>$permalink.$db->f("permanent_id"),'titel'=>$db->f("titel"),'fullname'=>htmlReady(get_fullname($db->f("user_id"))),'username'=>get_username($db->f("user_id"))));
                }
                return $ret;
        }

	function getTagCounter($limit=20) {
                $ret = array();
                $db = new DB_Seminar();
                $db->queryf("SELECT t.tag, COUNT(t.tag_id) anz FROM blog_tags t, blog_tag_entry ta WHERE t.tag_id=ta.tag_id GROUP BY t.tag ORDER BY 2 DESC %s",($limit?"LIMIT 0,$limit":""));
                while ($db->next_record()) {
                        $db->Record['tag_weight'] = $this->calcTagWeight($db->f('tag'));
                        array_push($ret, $db->Record);
                }
                array_multisort($ret, SORT_ASC);
                return $ret;
        }

        function getMaxTagCount($single='') {
                $db = new DB_Seminar();
                if (!$single)
                        $db->query("SELECT * FROM blog_tag_entry");
                else
                        $db->queryf("SELECT ta.* FROM blog_tag_entry ta, blog_tags t WHERE ta.tag_id=t.tag_id AND t.tag='%s'",$single);
                return $db->num_rows();
        }

        function calcTagWeight($tag) {
                $f_max = 10;
                $t_i = $this->getMaxTagCount($tag);

                $db = new DB_Seminar();
                $db->queryf("SELECT MAX(x.anz) anz_max, MIN(x.anz) anz_min FROM (SELECT t.tag, COUNT(t.tag_id) anz FROM blog_tags t, blog_tag_entry ta WHERE t.tag_id=ta.tag_id GROUP BY t.tag ORDER BY t.tag) x");
                $db->next_record();
                $anz_max = $db->f('anz_max');
                $anz_min = $db->f('anz_min');

                $delta = ($anz_max - $anz_min) / $f_max;
                $newThresholds = array();
                for ($x=1; $x<=$f_max; $x++) {
                        $newThresholds[$x] = 100 * log( ($anz_min + $x * $delta) + 2);
                }

                $fontSet = false;
                foreach ($newThresholds as $k=>$threshold) {
                        if ( (100 * log($t_i+2) <= $newThresholds[$k]) && !$fontSet) {
                                $fontSet = true;
                                return $k;
                        }
                }
        }

	function searchForTags($val) {
                $db = new DB_Seminar();
                $db->queryf("SELECT * FROM blog_tags WHERE LOWER(tag) LIKE LOWER('%s')",$val.'%');
                $ret = "<UL>";
                $suche = sprintf("/^(%s)/",$val);
                $ersetze = "<SPAN STYLE=\"font-weight:bold;\">\$1</SPAN>";
                while ($db->next_record()) {
                        $txt = preg_replace($suche,$ersetze,stripslashes(stripslashes($db->f('tag'))));
                        $ret .= "<LI>".$txt."</LI>";
                }
                $ret .= "</UL>";
                return $ret;
        }

	function searchForText($txt, $only_user=FALSE, $cat_id=FALSE, $datum=FALSE, $req_user_id=FALSE) {
		$db = new DB_Seminar();
		$ret = array();
		//$db->queryf("SELECT DISTINCT e.entry_id FROM blog_tags t, blog_tag_entry te, blog_entries e WHERE LOWER(t.tag) LIKE LOWER('%s') AND te.tag_id=t.tag_id AND e.entry_id=te.entry_id %s %s %s",
		$query = sprintf("SELECT e.entry_id, e.mkdate FROM blog_entries e WHERE e.visible=1 %s %s %s %s ORDER BY e.mkdate DESC",
			($txt ? "AND EXISTS (SELECT t.tag_id FROM blog_tags t, blog_tag_entry te WHERE t.tag_id=te.tag_id AND LOWER(tag) LIKE '%".$txt."%' AND te.entry_id=e.entry_id)" : ""),
			//'%'.$txt.'%',
			($only_user ? "AND e.user_id='".$only_user."'" :""),
			($cat_id ? "AND e.user_id='$req_user_id' AND EXISTS (SELECT c.entry_id FROM blog_category_entry c WHERE c.cat_id='$cat_id' AND c.entry_id=e.entry_id)" : ""),
			($datum ? "AND e.user_id='$req_user_id' AND FROM_UNIXTIME(e.mkdate, '%Y-%m-01')='".date('Y-m-01',$datum)."'" : ""));
		$db->query($query);
		while ($db->next_record()) {
			$e = new BlogEntry();
                        $e->load($db->f('entry_id'));
			if ($e->getVisible() == 1 || $e->getUserId() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root'))
	                        array_push($ret, $e);
		}
		return $ret;
	}

}

?>
