<?php

class BlogEntry {

	var $entry_id = '';
	var $user_id = '';
	var $titel = '';
	var $description = '';
	var $mkdate = 0;
	var $chdate = 0;
	var $visible = 0;
	var $permanent_id = '';

	function BlogEntry() {
		
	}

	function load($id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_entries WHERE entry_id='%s'", $id);
		$db->next_record();
		$this->entry_id = $db->f('entry_id');
		$this->user_id = $db->f('user_id');
		$this->titel = $db->f('titel');
		$this->description = $db->f('description');
		$this->mkdate = $db->f('mkdate');
		$this->chdate = $db->f('chdate');
		$this->visible = $db->f('visible');
		$this->permanent_id = $db->f('permanent_id');
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->entry_id) { // update
			$db->queryf("UPDATE blog_entries SET titel='%s', description='%s', visible=%d, chdate=UNIX_TIMESTAMP() WHERE entry_id='%s' AND user_id='%s'",mysql_escape_string($this->titel),mysql_escape_string($this->description),$this->visible,$this->entry_id,$this->user_id);
		} else { // insert
			$this->entry_id = md5(uniqid(time().$this->user_id));
			$db->queryf("INSERT INTO blog_entries(entry_id, user_id, titel, description, mkdate) VALUES ('%s', '%s', '%s', '%s', UNIX_TIMESTAMP())", $this->entry_id, $this->user_id, mysql_escape_string($this->titel), mysql_escape_string($this->description));
		}
	}

	function delete() {
		$db = new DB_Seminar();
		$db->queryf("DELETE FROM blog_entries WHERE entry_id='%s' AND user_id='%s'",$this->entry_id, $this->user_id);
		$db->queryf("DELETE FROM blog_comments WHERE entry_id='%s'",$this->entry_id);
	}

	function addComment($s) {
		$id =  md5(uniqid(time()));
                $content = trim($s);
		$db = new DB_Seminar();
                if (strlen($content) > 0 && $this->entry_id && $this->visible == 1) {
	                $db->queryf("INSERT INTO blog_comments (comment_id, entry_id, user_id, mkdate, content) VALUES ('%s','%s','%s',UNIX_TIMESTAMP(),'%s')",$id,$this->entry_id,$GLOBALS['auth']->auth["uid"],mysql_escape_string($content));
			return TRUE;
		} else {
			return FALSE;
		}
	}

	function deleteComment($comment_id) {
		$db = new DB_Seminar();
		$db->queryf("DELETE FROM blog_comments WHERE comment_id='%s' AND entry_id='%s'", $comment_id, $this->entry_id);
	}

	function getCommentCount() {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'",$this->entry_id);
		return $db->num_rows();
	}

	function getComments() {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_comments WHERE entry_id='%s' ORDER BY mkdate",$this->entry_id);
		while ($db->next_record())
			array_push($ret, $db->Record);
		return $ret;
	}

	function setEntryId($s) {
		$this->entry_id = $s;
	}
	
	function setUserId($s) {
		$this->user_id = $s;
	}

	function setTitel($s) {
		$this->titel = $s;
	}

	function setDescription($s) {
		$this->description = $s;
	}

	function setMkDate($s) {
		$this->mkdate = $s;
	}
	function setChdate($s) {
		$this->chdate = $s;
	}

	function setVisible($s) {
		$this->visible = $s;
	}


	function getEntryId() {
		return $this->entry_id;
	}

	function getUserId() {
		return $this->user_id;
	}

	function getTitel() {
		return stripslashes(stripslashes($this->titel));
	}

	function getDescription() {
		return stripslashes(stripslashes($this->description));
	}

	function getMkdate() {
		return $this->mkdate;
	}

	function getChdate() {
		return $this->chdate;
	}

	function getVisible() {
		return $this->visible;
	}

	function getPermanentId() {
		return $this->permanent_id;
	}

	function setTags($t) {
                $db = new DB_Seminar();
                $db2 = new DB_Seminar();
                if (trim($t) == "") return;
                $tags = explode(',',$t);
                $current_tags = $this->getTags();
                foreach ($tags as $t) {
                        $t = trim(strtolower($t));
                        if ($t == "") continue;
                        if (in_array($t, $current_tags)) continue;
                        $db->queryf("SELECT * FROM blog_tags WHERE tag='%s'",$t);
                        if ($db->next_record()) {
                                $db2->queryf("INSERT INTO blog_tag_entry (entry_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->entry_id, $db->f('tag_id'));
                        } else {
                                $id = md5(uniqid(time().$this->entry_id));
                                $db2->queryf("INSERT INTO blog_tags (tag_id, tag) VALUES ('%s','%s')", $id, mysql_escape_string($t));
                                $db2->queryf("INSERT INTO blog_tag_entry (entry_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->entry_id, $id);
                        }
                        array_push($current_tags, $t);
                }
        }

	function getTags() {
                $ret = array();
                $db = new DB_Seminar();
                $db->queryf("SELECT tag FROM blog_tags t, blog_tag_entry ta WHERE ta.entry_id='%s' AND t.tag_id=ta.tag_id", $this->entry_id);
                while ($db->next_record())
                        array_push($ret, stripslashes(stripslashes($db->f('tag'))));
                return $ret;
        }

        function removeTag($tag) {
                if (!$this->entry_id || !$tag) return;
                $db = new DB_Seminar();
                $db2 = new DB_Seminar();
                $db->queryf("SELECT ta.* FROM blog_tag_entry ta, blog_tags t WHERE t.tag='%s' AND ta.tag_id=t.tag_id",$tag);
                $anz = $db->num_rows();
                $db->next_record();
                $db2->queryf("DELETE FROM blog_tag_entry WHERE tag_id='%s' AND entry_id='%s'",$db->f('tag_id'),$this->entry_id);
                if ($anz == 1)
                        $db2->queryf("DELETE FROM blog_tags WHERE tag_id='%s' AND owner!='root'",$db->f('tag_id'));
        }

	function getCategories() {
		$db = new DB_Seminar();
		$ret = array();
		$db->queryf("SELECT c.* FROM blog_categories c, blog_category_entry ce WHERE ce.entry_id='%s' AND c.cat_id=ce.cat_id",$this->entry_id);
		while ($db->next_record())
			array_push($ret, $db->Record);
		return $ret;
	}

	function addCategory($cat_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_category_entry WHERE cat_id='%s' AND entry_id='%s'",$cat_id, $this->entry_id);
		if (!$db->next_record()) {
			$db->queryf("INSERT INTO blog_category_entry (cat_id, entry_id) VALUES ('%s','%s')",$cat_id, $this->entry_id);
		}
	}

	function removeCategory($cat_id) {
		$db = new DB_Seminar();
		$db->queryf("DELETE FROM blog_category_entry WHERE cat_id='%s' AND entry_id='%s'",$cat_id, $this->entry_id);
	}

}

?>
